<%@page contentType="text/html; charset=utf-8" %> 
<%@taglib uri='http://www.sas.com/taglib/sas' prefix='sas'%>
<%@page	import="com.sas.analytics.mfg.warranty.webapp.lpage.config.ConfigConstants"%>
<%@page	import="com.sas.analytics.mfg.warranty.webapp.lpage.util.WebUtil"%>
<%@page import="com.sas.analytics.mfg.warranty.core.Configuration"%>
<%@page import="com.sas.servlet.tbeans.tableview.TableCellContentsRenderer"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.CellContentsNoRowsRenderer"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableViewComposite"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableView"%>
<%@page import="com.sas.actionprovider.ActionOrderList"%>
<%@page import="com.sas.actionprovider.support.ActionProviderSupportTypes"%>
<%@page import="com.sas.actionprovider.support.tableview.HttpTableViewSupport"%>
<%@page import="com.sas.servlet.tbeans.tableview.AbstractBaseTableView"%>
<%@page import="com.sas.actionprovider.HttpActionProvider"%>
<%@page import="javax.swing.table.TableModel"%>
<%@page import="java.util.Locale"%>
<%@page import="java.util.List"%>
<%@page import="com.sas.analytics.mfg.warranty.webapp.lpage.BaseTableCellContentRenderer"%>
<%@page import="com.sas.servlet.util.JavaScriptIncludeHandler"%>
<%@page errorPage="error.jsp" %>
<jsp:include page="common.jsp" />
<!-- Displays the list of all reports for the selected category  -->

<!-- styles and scripts are necessary since iframe doesnt inherit anything from parent-->
<%
String contextPath=request.getContextPath();
String serverPath=WebUtil.getRequestScheme(request) + request.getServerName()+":" + request.getServerPort();
String scriptsPath=serverPath+contextPath+"/scripts/";
request.setAttribute(JavaScriptIncludeHandler.JS_PATH,scriptsPath);

%>


<sas:StyleSheet styleNames="SAS Style,SAS Portal"/>
<sas:InitializeComponents/>

<script language='javascript'>

function invokeContentUrlByType(pdfUrl, htmlUrl, csvUrl)
{
		var publicReportsForm=window.parent.document.getElementById("publicReportsForm");
		var actionType = publicReportsForm.publicReportAction.value;
		
		if (actionType == "HTML")
		{
			window.open(htmlUrl);
		}
		else if (actionType == "PDF")
		{
			window.open(pdfUrl);
		}
		else if (actionType == "CSV")
		{
			window.open(csvUrl);
		}
}

</script>

<%
String publicReportsCategory=request.getParameter(ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME);
String publicReportsDetailsControllerAction="PublicReportsDetailsControllerAction.do?"+
	   ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME+"="+publicReportsCategory+"&";
String publicReportsPortletName=Configuration.CONFIG_PARAM_PUBLIC_REPORTS_PORTLET_NAME.getValue();
String controllerURL=WebUtil.makePortletAction(publicReportsPortletName,publicReportsDetailsControllerAction);
TableModel sortableTable=(TableModel)session.getAttribute(ConfigConstants.SESSION_PUBLIC_REPORTS_TABLE_MODEL);
String stringRowPageSize=Configuration.PUBLIC_REPORTS_TABLE_ROW_PAGE_SIZE.getValue();
int rowPageSize=Integer.parseInt(stringRowPageSize);
rowPageSize=WebUtil.getRowPageSize( sortableTable,rowPageSize);
String stringColumnPageSize=Configuration.PUBLIC_REPORTS_TABLE_COLUMN_PAGE_SIZE.getValue();
int columnPageSize=Integer.parseInt(stringColumnPageSize);
columnPageSize=WebUtil.getColumnPageSize(sortableTable,columnPageSize);

%>

 <sas:TableViewComposite 
            id="PublicReportsTableViewComp"
			scope="session"
            render="false">    
                    
</sas:TableViewComposite>
<%
		HttpActionProvider newActionProvider=new HttpActionProvider();
		newActionProvider.setLocale( ( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE ) );
		newActionProvider.setControllerURL(controllerURL);

		TableViewComposite tableViewComposite=(TableViewComposite)session.getAttribute(ConfigConstants.SESSION_PUBLIC_REPORTS_TABLE_VIEW_NAME);
		tableViewComposite.setActionProvider(null);
		tableViewComposite.setActionProvider(newActionProvider);
		tableViewComposite.setModel(sortableTable);
		TableView table =(TableView)tableViewComposite.getComponent(tableViewComposite.TABLEVIEW_TABLEDATA);
		table.setColumnsResizable(true);
		table.setTextWrapping(AbstractBaseTableView.WRAP_ALL);
		ActionOrderList columnHeaderList = newActionProvider.getActionOrderList(ActionProviderSupportTypes.TABLEVIEW_SUPPORT, table, HttpTableViewSupport.COLUMN_HEADER_AREA);
		ActionOrderList actionSubList=(ActionOrderList)columnHeaderList.get(0);
		actionSubList.remove(HttpTableViewSupport.EXPORT_TO_ACTION);
		
		List sortColumnsProfile = (List)session.getAttribute(ConfigConstants.SESSION_SORT_ORDER_COLUMNS_SUFFIX);
		List sortDirectionsProfile = (List)session.getAttribute(ConfigConstants.SESSION_SORT_ORDER_DIRECTIONS_SUFFIX);
		if (sortColumnsProfile != null && sortDirectionsProfile != null)
		{
			table.setSortedColumns(sortColumnsProfile, sortDirectionsProfile);
		}

		TableCellContentsRenderer defaultNoRowRenderer = table.getDefaultNoRowsRenderer( );
		if ( defaultNoRowRenderer instanceof CellContentsNoRowsRenderer ) {
			String defaultNoRowsText = WebUtil.getStringResource("PublicReports.NoRows.txt", request );
			( ( CellContentsNoRowsRenderer ) defaultNoRowRenderer).setText( defaultNoRowsText );
		}

	    String viewExportColumnLabel = WebUtil.getStringResource("Table.customColumn.exportAction.label.txt", request );
	    String reportNameColumnLabel = WebUtil.getStringResource("publicReportsTable.reportNameColumn.label.txt", request );
	    String reportIdProxyColumnName = Configuration.VIEW_EXPORT_COLUMN_NAME_KEY.getValue();

	    String exportImagePath=serverPath + contextPath +"/images/Export.gif";

		table.setDefaultRenderer(new BaseTableCellContentRenderer(( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE )));

		String viewPdfActionUrl="DisplayPublicReportsPdfAction.do?"+
			   ConfigConstants.REQUEST_SELECTED_ROW_NUMBER +"=%MODEL_ROW_NUMBER&"+
			   ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME+"="+publicReportsCategory+"&"+
			   ConfigConstants.REQUEST_SELECTED_REPORT_ID+"=%" + reportIdProxyColumnName + "&";
			   
		String viewHtmlActionUrl="DisplayPublicReportsGraphAction.do?"+
			   ConfigConstants.REQUEST_SELECTED_ROW_NUMBER +"=%MODEL_ROW_NUMBER&"+
			   ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME+"="+publicReportsCategory+"&"+
			   ConfigConstants.REQUEST_SELECTED_REPORT_ID+"=%" + reportIdProxyColumnName + "&";

		String listCSVDownloadsAction="ListCSVDownloadsAction.do?"+
			   ConfigConstants.REQUEST_SELECTED_ROW_NUMBER +"=%MODEL_ROW_NUMBER&"+
			   ConfigConstants.REQUEST_SELECTED_PUBLIC_REPORT_CATAGORY_NAME+"="+publicReportsCategory+"&"+
			   ConfigConstants.REQUEST_SELECTED_REPORT_ID+"=%" + reportIdProxyColumnName + "&";
%>

<sas:TableViewComposite 
           ref="PublicReportsTableViewComp"
           scope="session"
		   locale="<%=( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE )%>"
           render="true">  
    <sas:TableView 
        id="PublicReportsSAViewer"							
        rowHeaderVisible="true" 
        cellPadding="1" 
        cellSpacing="3"
        borderWidth="1" 
        autoCreateColumnsFromModel="true"  
        rowPageSize="<%=rowPageSize %>" 
        columnPageSize="<%= columnPageSize%>"
        widthPercentage="100"> 
        
        <sas:Columns>
            <sas:Column headerValue="<%=viewExportColumnLabel%>" modelIndex="<%=ConfigConstants.VIEW_EXPORT_COL%>" hold="LEFT">                        	                                     
                <sas:CellRenderer>
                    <sas:CellContentsSimpleTemplateRenderer> 
                        <a href="javascript:" onclick='javascript:invokeContentUrlByType("<%=viewPdfActionUrl%>", "<%=viewHtmlActionUrl%>", "<%=listCSVDownloadsAction%>");' ><img src="<%=exportImagePath%>" border="0"></a>
                    </sas:CellContentsSimpleTemplateRenderer>
                </sas:CellRenderer>
            </sas:Column>                        
            <sas:Column headerValue="<%=reportNameColumnLabel%>" modelIndex="<%=ConfigConstants.REPORT_NAME_COL %>" hold="LEFT">
            </sas:Column>
        </sas:Columns>	
    </sas:TableView>			
</sas:TableViewComposite>           
