<%@page contentType="text/html; charset=utf-8" %> 
<%@taglib uri='http://www.sas.com/taglib/sas' prefix='sas'%>
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.config.ConfigConstants"%>
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.util.WebUtil"%>
<%@page import="com.sas.analytics.mfg.warranty.core.Configuration"%>
<%@page import="com.sas.actionprovider.ActionOrderList"%>
<%@page import="com.sas.actionprovider.support.ActionProviderSupportTypes"%>
<%@page import="com.sas.actionprovider.support.tableview.HttpTableViewSupport"%>

<%@page import="com.sas.servlet.tbeans.tableview.TableCellContentsRenderer"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.CellContentsNoRowsRenderer"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableView"%>
<%@page import="com.sas.servlet.tbeans.tableview.html.TableViewComposite"%>
<%@page import="com.sas.servlet.tbeans.tableview.AbstractBaseTableView"%>
<%@page import="com.sas.actionprovider.HttpActionProvider"%>
<%@page import="javax.swing.table.TableModel"%>
<%@page import="java.util.Locale"%>
<%@page import="com.sas.analytics.mfg.warranty.webapp.lpage.BaseTableCellContentRenderer"%>
<%@page import="com.sas.analytics.mfg.warranty.coreapi.ei.client.EIType"%>
<%@page import="com.sas.servlet.util.JavaScriptIncludeHandler"%>
<%@page errorPage="error.jsp" %>
<jsp:include page="common.jsp" />
<%
String contextPath=request.getContextPath();
String serverPath=WebUtil.getRequestScheme(request) + request.getServerName()+":" + request.getServerPort();
String scriptsPath=serverPath+contextPath+"/scripts/";
request.setAttribute(JavaScriptIncludeHandler.JS_PATH,scriptsPath);
%>
<head>
<sas:StyleSheet styleNames="SAS Style,SAS Portal"/>
<sas:InitializeComponents/>

<script language="javascript">
function invokeContentUrlByType(pdfUrl, htmlUrl)
{
		// Access the output type value 
		var actionType = window.parent.document.getElementById("exportOutputTypeValue").value;
		if (actionType == "HTML")
		{
			window.open(htmlUrl);
		}
		else if (actionType == "PDF")
		{
			window.open(pdfUrl);
		}
}
</script>
</head>

<!-- styles and scripts are necessary since iframe doesnt inherit anything from parent-->
<%
    String selectedEICategoryId=(String) session.getAttribute(ConfigConstants.SESSION_SELECTED_EI_CATAGORY_NAME);
    EIType eiType=EIType.getEITypeFromOrdinalValue(Integer.parseInt(selectedEICategoryId));
    String selectedRunGroupID=(String) session.getAttribute(ConfigConstants.SESSION_SELECTED_RUN_GROUP_ID);	   	
    String controllerAction="EmergingIssuesDetailsControllerAction.do?"+ ConfigConstants.REQUEST_SELECTED_EI_CATAGORY_NAME+"="+selectedEICategoryId +"&"+
						  ConfigConstants.REQUEST_SELECTED_RUN_GROUP_ID+"="+selectedRunGroupID +"&";

    String eiPortletName=Configuration.CONFIG_PARAM_EI_PORTLET_NAME.getValue();
    String controllerURL=WebUtil.makePortletAction(eiPortletName,controllerAction);

    String viewExportColumnLabel = WebUtil.getStringResource("Table.customColumn.exportAction.label.txt", request );
    String alertIdProxyColumnName = Configuration.VIEW_EXPORT_COLUMN_NAME_KEY.getValue();

	String exportImagePath=serverPath + contextPath +"/images/Export.gif";

	Boolean isModelEmpty= ( Boolean) request.getAttribute( ConfigConstants.REQUEST_IS_EI_TABLE_EMPTY );
	String stringRowPageSize=Configuration.EI_TABLE_ROW_PAGE_SIZE.getValue();
	int rowPageSize=Integer.parseInt(stringRowPageSize);
	rowPageSize=WebUtil.getRowPageSize( (TableModel)session.getAttribute(ConfigConstants.SESSION_EI_TABLE_MODEL),rowPageSize);

	String stringColumnPageSize=Configuration.EI_TABLE_COLUMN_PAGE_SIZE.getValue();
	int columnPageSize=Integer.parseInt(stringColumnPageSize);
	columnPageSize=WebUtil.getColumnPageSize((TableModel)session.getAttribute(ConfigConstants.SESSION_EI_TABLE_MODEL),columnPageSize);
	TableModel sortableTable=(TableModel)session.getAttribute(ConfigConstants.SESSION_EI_TABLE_MODEL);

    String eiActionCommonParameters=
						ConfigConstants.REQUEST_SELECTED_ROW_NUMBER +"=%MODEL_ROW_NUMBER&" + 
						ConfigConstants.REQUEST_SELECTED_EI_CATAGORY_NAME+"="+selectedEICategoryId +"&"+
						ConfigConstants.REQUEST_SELECTED_RUN_GROUP_ID+"="+selectedRunGroupID +"&";

	String eiPDFActionUrl="DisplayEIPdfAction.do?"+
					ConfigConstants.REQUEST_SELECTED_ALERT_KEY +"=%" + alertIdProxyColumnName + "&"+
					eiActionCommonParameters;

	String eiHTMLActionUrl="DisplayEIGraphAction.do?"+
					ConfigConstants.REQUEST_SELECTED_ALERT_KEY +"=%" + alertIdProxyColumnName + "&"+
					eiActionCommonParameters;

	String tableId = ConfigConstants.SESSION_EI_TABLE_VIEW_NAME;

	if( isModelEmpty != null && isModelEmpty.booleanValue( ) ) {
		tableId = "EmptyEITableViewComp";
%>
	<sas:TableViewComposite 
            id="EmptyEITableViewComp"
			model="<%=ConfigConstants.SESSION_EI_TABLE_MODEL%>" scope="session"
            render="false">    
					
	</sas:TableViewComposite>

<%
} else {
%>

	<sas:TableViewComposite 
            id="EITableViewComp"
			model="<%=ConfigConstants.SESSION_EI_TABLE_MODEL%>" scope="session"
            render="false">    
	</sas:TableViewComposite>

<%
}
%>
<%
		HttpActionProvider newActionProvider=new HttpActionProvider();
		newActionProvider.setLocale( ( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE ) );
		newActionProvider.setControllerURL(controllerURL);
		TableViewComposite tableViewComposite=(TableViewComposite)session.getAttribute( tableId);
		tableViewComposite.setActionProvider(null);
		tableViewComposite.setActionProvider(newActionProvider);
		TableModel model = ( TableModel) session.getAttribute(ConfigConstants.SESSION_EI_TABLE_MODEL);
		tableViewComposite.setModel( model );
		TableView table =(TableView)tableViewComposite.getComponent(tableViewComposite.TABLEVIEW_TABLEDATA);
		table.setColumnsResizable(true);
		table.setTextWrapping(AbstractBaseTableView.WRAP_ALL);
		ActionOrderList columnHeaderList =
		newActionProvider.getActionOrderList(
		ActionProviderSupportTypes.TABLEVIEW_SUPPORT,
		table,
		HttpTableViewSupport.COLUMN_HEADER_AREA);
		ActionOrderList actionSubList=(ActionOrderList)columnHeaderList.get(0);
		actionSubList.remove(HttpTableViewSupport.EXPORT_TO_ACTION);
		TableCellContentsRenderer defaultNoRowRenderer = table.getDefaultNoRowsRenderer( );
		if ( defaultNoRowRenderer instanceof CellContentsNoRowsRenderer ) {
			String defaultNoRowsText = WebUtil.getStringResource("EI.NoRows.txt", request );
			( ( CellContentsNoRowsRenderer ) defaultNoRowRenderer).setText( defaultNoRowsText );
		}
		table.setDefaultRenderer(new BaseTableCellContentRenderer(( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE )));
%>

<%
if( isModelEmpty != null && isModelEmpty.booleanValue( ) ) {
%>

		<sas:TableViewComposite 
				   ref="EmptyEITableViewComp"
				   scope="session"
				   locale="<%= ( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE ) %>"
				   render="true"> 
            <sas:TableView columnHeaderVisible="true" 
                           rowHeaderVisible="false" 
                           rowPageSize="<%=rowPageSize %>" 
                           columnPageSize="<%=columnPageSize%>" 
                           widthPercentage="100">
            </sas:TableView>
		</sas:TableViewComposite>

<%
} else {
%>

	<sas:TableViewComposite 
			   ref="EITableViewComp"
			   scope="session"
   			   locale="<%= ( Locale) request.getAttribute( ConfigConstants.REQUEST_USER_LOCALE ) %>"
			   render="true">  
        <sas:TableView id="SAViewer"							
								rowHeaderVisible="true" cellPadding="1" cellSpacing="3"
								borderWidth="1" autoCreateColumnsFromModel="true"  rowPageSize="<%=rowPageSize %>" columnPageSize="<%= columnPageSize%>"
								widthPercentage="100">
<%				if(!eiType.equals(EIType.NEWMODEL))
				 {%>
					<sas:Columns>
                        <sas:Column headerValue='<%=viewExportColumnLabel%>' modelIndex="<%=ConfigConstants.VIEW_EXPORT_COL%>" hold="LEFT">                        	                                     
                            <sas:CellRenderer>
                                <sas:CellContentsSimpleTemplateRenderer>
                                    <a href="javascript:" onclick='javascript:invokeContentUrlByType("<%=eiPDFActionUrl%>", "<%=eiHTMLActionUrl%>");' ><img src="<%=exportImagePath%>" border="0"></a>
                                </sas:CellContentsSimpleTemplateRenderer>
                            </sas:CellRenderer>                        
                        </sas:Column>
                    </sas:Columns>
<%
				 }
%>
		</sas:TableView>
	</sas:TableViewComposite>           

<%
}
%>

