<%@page contentType="text/html; charset=utf-8" %> 
 <%@taglib uri='http://www.sas.com/taglib/sas' prefix='sas'%>
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.config.ConfigConstants"%>
<%@page
	import="com.sas.analytics.mfg.warranty.webapp.lpage.util.WebUtil"%>
<%@page	import="com.sas.analytics.mfg.warranty.core.Configuration"%>
<%@page import="java.util.List"%>
<%@page import="java.util.Iterator"%>

<%@page errorPage="error.jsp" %>
<jsp:include page="LocaleSetting.jsp" />
<jsp:include page="common.jsp" />
<jsp:include page="Title.jsp" />
<!--   Scriplet to get the category list 													-->
<%
	List publicReportsCategories = (List) request.getSession().getAttribute(ConfigConstants.SESSION_PUBLIC_REPORTS_CATEGORIES);
	Iterator publicReportsCategoriesIterator = publicReportsCategories.iterator();
%>

<!--   Java script to handle the category and run group selected changed events 			-->
<%@page import="com.sas.analytics.mfg.warranty.core.Configuration"%>
<%@page import="com.sas.analytics.mfg.warranty.coreapi.report.client.ReportCategory"%>
<script language="javascript">
	/*
	create array of size rows
	*/
	var rows=<%= publicReportsCategories.size()%>;
	var publicReportCategoryResults=new publicReportCategoryResult(rows);

	/*
	class publicReportsCategoryResult
	*/
	function publicReportCategoryResult(categoryName){
		this.categoryName=categoryName;
	} // End of publicReportsCategoryResult

<%
	int index=0;
	String descriptorName;
	while(publicReportsCategoriesIterator.hasNext()){
		ReportCategory result=(ReportCategory)publicReportsCategoriesIterator.next();
		descriptorName	=result.getLabel();
		%>
		publicReportCategoryResults[<%=index%>]=new publicReportCategoryResult('<%=WebUtil.applyEscapeProcessing(descriptorName)%>');
<%
		index++;
	} // End of while
%>

<%
String publicReportsPortletName=Configuration.CONFIG_PARAM_PUBLIC_REPORTS_PORTLET_NAME.getValue();
String publicReportsDetailsAction="DisplayPublicReportsDetailsAction.do";
String publicReportsDetailsPortletAction=WebUtil.makePortletAction(publicReportsPortletName,publicReportsDetailsAction);

String processingActionName ="PublicReportsProcessingAction.do";
String processingActionPath = WebUtil.makePortletAction(publicReportsPortletName,processingActionName);

%>

function clearFilterFields( publicReportsForm ) {
	// clear search text, select default search criteria (contains) 
	var srchText=publicReportsForm.<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_TEXT_NAME %>;
	srchText.value="";
	var containsOption=publicReportsForm.<%=ConfigConstants.REQUEST_PUBLIC_REPORTS_FILTER_SEARCH_CRITERIA_NAME %>[0];
	containsOption.checked=true;		
}

	// Start of publicReportsCategorySelectionChanged
	function publicReportsCategorySelectionChanged(categoryDropDown){
		var publicReportForm = document.getElementById('publicReportsForm');	
		publicReportForm.action="<%=publicReportsDetailsPortletAction%>"+
		"?<%=ConfigConstants.REQUEST_PARAM_CATEGORY_SELECTION_CHANGED%>=true&";				
		var publicReportsDetailsIFrame = document.getElementById('publicReportsDetails');
		publicReportsDetailsIFrame.src = publicReportsDetailsIFrame.src;	
		
	} // End of publicReportsCategorySelectionChanged

</script>	

<form id="publicReportsForm" name="publicReportsForm" method="post"	target="publicReportsDetails"  action="<%=publicReportsDetailsPortletAction%>">
<table rows="5" cols="1" width="<%=Configuration.PUBLIC_REPORTS_PORTLET_WIDTH.getValue() %>">
	<tr>
	<!-- Row 1 -->
		<td>
		<table rows="1" cols="2">
			<!-- Row 1.1 -->
			<tr>
				<td>
				  <%=WebUtil.getStringResource("PublicReportsList.category.control.label.txt", request )%>
				</td>
				<td><select name="publicReportCategories"
					onChange="publicReportsCategorySelectionChanged(this)">
					<%
								//TODO: Check if we can separate the java code and html with this jsp more elegantly

								String categoryName = null;
								String id=null;
								for( int catIndex = 0; catIndex < publicReportsCategories.size( ); catIndex++ ) {
									ReportCategory result=(ReportCategory)publicReportsCategories.get(catIndex);
									categoryName = result.getLabel();
									id=result.getId().getInternalRep();																		
									if( catIndex == 0 ) {
										%>	
					<option selected value="<%=id%>"><%=categoryName%>
					</option>
					<% } else {
						%>
						<option value="<%=id%>"><%=categoryName%>
						</option>
						<%
										}
									}
						%>
				</select></td>
				
				<td>&nbsp;</td>
				
				<td><%=WebUtil.getStringResource("Table.customColumn.control.label.txt", request )%></td>
				<td>
				    <select name="publicReportAction">
					    <option selected value="HTML"><%=WebUtil.getStringResource("Table.customColumn.viewHTML.label.txt", request )%></option>
					    <option value="PDF"><%=WebUtil.getStringResource("Table.customColumn.viewPDF.label.txt", request )%></option>
					    <option value="CSV"><%=WebUtil.getStringResource("Table.customColumn.viewCSV.label.txt", request )%></option>
					</select>
				</td>
			</tr>
			</table>
			</td>
	</tr>
	<tr>
	<!-- Row 2 -->
		<td><HR></td>
	</tr>
	<tr>
	<!-- Row 3 -->
		<td >
			<jsp:include page="PublicReportsFilter.jsp" flush="true"/>

		</td>
	</tr>
	<tr>
	<!-- Row 4 -->
		<td><HR></td>
	</tr>

	<tr>
	<!-- Row 5 -->
		<td>
			<iframe id="publicReportsDetails" 
					width="<%=Configuration.PUBLIC_REPORTS_TABLE_WIDTH.getValue() %>" height="<%=Configuration.PUBLIC_REPORTS_TABLE_HEIGHT.getValue() %>" name="publicReportsDetails" src="<%=processingActionPath %>" frameborder="0" scrolling="<%=Configuration.PUBLIC_REPORTS_TABLE_SCROLLING_PROPERTIY.getValue() %>">
			</iframe>
		</td>
	</tr>
</table>

</form>

